//=============================================================================
// UTent.Tent  - An Upside Down Tentacle thingy.  2015 - Mr.Loathsome
//=============================================================================
class Tent extends Tentacle;

#exec TEXTURE IMPORT NAME=AlCapownedTxt FILE=Textures\rkbo.pcx
#exec TEXTURE IMPORT NAME=boringtent FILE=Textures\boringtent.pcx
#exec TEXTURE IMPORT NAME=lavatent FILE=Textures\lavatent.pcx

var() int TentColor;
var() Texture AltTexture;
var() int StartRoll;
var() bool bSpiderMode;
var bool bInitDone;

function PostBeginPlay()
{
	bInitDone = False;
	if ((!bCanWalk) && (StartRoll == 32768))
		SetPhysics(PHYS_Falling);
	Super.PostBeginPlay();
}

function bool SetEnemy( Pawn NewEnemy )
{
	local bool result, bCWHold;

	bCWHold = bCanWalk;
	result = Super.SetEnemy(NewEnemy);
	bCanWalk = bCWHold;
	return result;
}

function PickSkin()
{
	local int SkinNum;

	if (AltTexture != None)
		MultiSkins[1] = AltTexture;
	else
	{
	if (TentColor >= 4) { SkinNum = Rand(4); } else { SkinNum = TentColor; }
	Switch(SkinNum)
		{
		Case 3:
			MultiSkins[1] = Texture'boringtent';
			break;
		Case 2:
			MultiSkins[1] = Texture'lavatent';
			break;
		Case 1:
			MultiSkins[1] = Texture'AlCapownedTxt';
			break;
		Case 0:
			MultiSkins[1] = Texture'JTentacle1';
		}
	}
}

simulated function AddVelocity( vector NewVelocity )
{
	if ((Physics == PHYS_None) && (Health > 0))
		Velocity = vect(0,0,0);
	else
		Velocity += NewVelocity;
}

function PreSetMovement()
{
	MinHitWall = -0.6;
	bCanOpenDoors = false;
	bCanDoSpecial = false;
}

function SetMovementPhysics();  // Never do this unless you are Loathsome.....

singular function Falling();    // Don't do this either.

function PlayDying(name DamageType, vector HitLocation)
{
	PlaySound(Die, SLOT_Talk, 3 * TransientSoundVolume);
	if ( FRand() > 0.660 )
	{
		DesiredRotation = Rotation;
		DesiredRotation.Roll = 0.0;
		SetRotation(DesiredRotation);
		PlayAnim('Dead2', 0.7, 0.1);
	}
	else
	if ( FRand() > 0.660 )
	{
		TweenAnim('TakeHit', 3.0);
	}
	else
	{
		DesiredRotation = Rotation;
		DesiredRotation.Roll = 0.0;
		SetRotation(DesiredRotation);
		PlayAnim('Dead1', 0.6, 0.2);
	}
}

function Carcass SpawnCarcass()
{
	local carcass carc;

	carc = Spawn(CarcassType);
	if ( carc != None )
	{
		carc.Initfor(self);
		carc.MultiSkins[1] = Self.MultiSkins[1];
	}
	return carc;
}

function SmackTarget()
{
	if ((Target != None) && (!Pawn(Target).IsA('Tentacle')) && (Pawn(Target).Health > 0) && ( MeleeDamageTarget(WhipDamage, (WhipDamage * 1000 * Normal(Target.Location - Location))) ))
		PlaySound(Whip, SLOT_Interact);		
}

function PlayRangedAttack()
{
	local vector projStart;

	MakeNoise(1.0); 
	if ((Physics == PHYS_None) || (Rotation.Roll == 32768))
		projStart = Location - CollisionHeight * vect(0,0,-1.2);
	else
		projStart = Location + CollisionHeight * vect(0,0,-1.0);

	spawn(RangedProjectile ,self,'',projStart,AdjustAim(ProjectileSpeed, projStart, 900, bLeadTarget, bWarnTarget));
	PlayAnim('Shoot');
}

function PlayVictoryDance()
{
	PlaySound(whip, SLOT_Interact);
	LoopAnim('Smack', 0.6);
}
	
state MeleeAttack   // Don't do this unless you are very Loathsome....
{
Begin:
FaceTarget:
ReadyToAttack:
Attacking:
DoneAttacking:

	GotoState('RangedAttack', 'Challenge');
}

state Attacking
{
ignores SeePlayer, HearNoise, Bump, HitWall;

	function ChooseAttackMode()
	{
		if (Physics == PHYS_Swimming)
		{
			Super.ChooseAttackMode();
			return;
		}

		if ((Enemy == None) || (Enemy.Health <= 0))
		{
			if ((OldEnemy != None) && (OldEnemy.Health > 0)) 
				{
				Enemy = OldEnemy;
				OldEnemy = None;
				}
			else
			{
				GotoState('Waiting');
				return;
			}
		}
			
		if (!LineOfSightTo(Enemy))
		{
			if ((bCanWalk) && (FRand() > 0.50))
				GotoState('Wandering');
			else
			if ((bCanWalk) && (FRand() > 0.50))
				GotoState('Roaming');
			else
				GotoState('StakeOut');
		}
		else
		{
			if (StartRoll == 0)
				SetPhysics(PHYS_Rotating);
			else
			{
				if (bCanWalk)
				{
					if (bSpiderMode)
						SetPhysics(PHYS_Spider);
					else
						SetPhysics(PHYS_Walking);
					bHunting = True;
				}
				else
				{
					SetPhysics(PHYS_None);
				}
			}
		GotoState('RangedAttack');
		}
	}
}

state RangedAttack
{
//ignores SeePlayer, HearNoise, HitWall;
ignores HitWall;

	function FlipR(Rotator newRot)
	{
		if (Physics == PHYS_None)
		{
			if (newRot.Roll > 49152) { newRot.Roll -= StartRoll; }
			else if (newRot.Roll < 16384) { newRot.Roll += StartRoll; }
		}
		DesiredRotation = newRot;
		SetRotation(newRot);
	}

	function TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation, 
						Vector momentum, name damageType)
	{
		Global.TakeDamage(Damage, instigatedBy, hitlocation, momentum, damageType);
		if ( health <= 0 )
			return;
		if (NextState == 'TakeHit')
		{
			NextState = 'RangedAttack';
			NextLabel = 'Begin';
		}
	}

	function StopWaiting()
	{
		Timer();
	}

	function EnemyNotVisible()
	{
		////log("enemy not visible");
		//let attack animation completes
	}

	function KeepAttacking()
	{
		if ( !bFiringPaused && ((FRand() > ReFireRate) || (Enemy == None) || (Enemy.Health <= 0) || !CanFireAtEnemy()) ) 
			GotoState('Attacking');
	}

	function Timer()
	{
		if ( bFiringPaused )
		{
			TweenToRunning(0.12);
			GotoState(NextState, NextLabel);
		}
	}

	function AnimEnd()
	{
		GotoState('RangedAttack', 'DoneFiring');
	}
	
	function BeginState()
	{
		Target = Enemy;
		Disable('AnimEnd');
		bReadyToAttack = false;
		if ( bFiringPaused )
		{
			SetTimer(SpecialPause, false);
			SpecialPause = 0;
		}
	FlipR(Rotation);
	}
	
	function EndState()
	{
		bFiringPaused = false;
	}

Challenge:
	Disable('AnimEnd');
	Acceleration = vect(0,0,0); //stop
	FlipR(Rotator(Enemy.Location - Location));
	PlayChallenge();
	FinishAnim();
	TweenToFighter(0.1);
	Goto('FaceTarget');

Begin:
	if ( Enemy == None )
		GotoState('Attacking');
	Acceleration = vect(0,0,0); //stop
	FlipR(Rotator(Enemy.Location - Location));
	TweenToFighter(0.15);
	
FaceTarget:
	Disable('AnimEnd');
	if (NeedToTurn(Enemy.Location))
	{
		PlayTurning();
		TurnToward(Enemy);
		TweenToFighter(0.1);
	}
	FinishAnim();

ReadyToAttack:
	if (VSize(Location - Enemy.Location) < 0.9 * MeleeRange + CollisionRadius + Enemy.CollisionRadius)
	{
		PlayAnim('Smack');
		FlipR(Rotator(Enemy.Location - Location));
		Goto('FaceTarget');
	}
	if (bCanWalk)
	{
		if (FRand() > 0.50)
			PlayRunning();
		else
			PlayWalking();
		FlipR(Rotator(Enemy.Location - Location));
		if (LineOfSightTo(Enemy))
		{
			PlayTurning();
			TurnToward(Enemy);
			MoveToward(Enemy);
		}
		else
		{
			PlayTurning();
			TurnTo(LastSeenPos);
			MoveTo(LastSeenPos);
		}
	}

	FlipR(Rotator(Enemy.Location - Location));
	PlayRangedAttack();
	Enable('AnimEnd');
Firing:
	if (Enemy == None )
		GotoState('Attacking');
	TurnToward(Enemy);

	if (VSize(Location - Enemy.Location) > 0.9 * MeleeRange + CollisionRadius + Enemy.CollisionRadius)
		Goto('Firing');
DoneFiring:
	Disable('AnimEnd');
	KeepAttacking();  
	Goto('FaceTarget');
}

state Waiting
{
	function FlipR(Rotator newRot)
	{
		if (Physics != PHYS_Spider)
		{
			if (newRot.Roll > 49152) { newRot.Roll -= StartRoll; }
			else if (newRot.Roll < 16384) { newRot.Roll += StartRoll; }
		}
		DesiredRotation = newRot;
		SetRotation(newRot);
	}

	function EnemyAcquired()
	{
		GotoState('Acquisition', 'PlayOut');
	}
	
	function AnimEnd()
	{
		PlayWaiting();
		bStasis = true;
	}
 
	function Landed(vector HitNormal)
	{
	}

	function BeginState()
	{
		Enemy = None;
		bStasis = false;
		Acceleration = vect(0,0,0);
		SetAlertness(0.0);
		if (!bInitDone) { PickSkin(); bInitDone = True; }
//		if (bCanWalk) FlipR(Rotation);
	}

TurnFromWall:

Begin:
	if (Region.Zone.bWaterZone)
	{
		SetPhysics(PHYS_Swimming);
	}
//	FlipR(Rotation);
	TweenToWaiting(0.4);
	bReadyToAttack = false;
KeepWaiting:
	FlipR(Rotation);
	NextAnim = '';
}

//     PeripheralVision=-5.000000
//     HearingThreshold=50.000000
//     FovAngle=360.000000

defaultproperties
{
     TentColor=0
     AltTexture=None
     StartRoll=32768
     WhipDamage=20
     Health=100
     MeleeRange=200.000000
     bCanJump=False
     bCanWalk=False
     bCanSwim=True
     bCanFly=False
     bSpiderMode=False
     PeripheralVision=-1.000000
     JumpZ=80.000000
     MaxStepHeight=50.000000
     GroundSpeed=240.000000
     AccelRate=400.000000
     Buoyancy=200.000000
     MenuName="UTent"
     NameArticle=" a freaking "
     ReducedDamageType=AllEnvironment
     ReducedDamagePct=-1
}

